<?php

require_once (dirname(__FILE__) . "/URFAClient.php");

class URFAClient_User5 extends URFAClient
{
	/**
	 * Возвращает объект URFAClient_Admin используя текущие настройки подключения
	 * 
	 * @return URFAClient_Admin
	 */
	public function getURFAClient_Admin($login, $pass, $ssl = true)
	{
		return new URFAClient_Admin($login, $pass, $this->address, $this->port, $ssl);
	}
	
	function rpcs_user5_get_services_name($service_id) { //-0x402b
		$ret=array();
		if (!$this->connection->urfa_call(-0x402b)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($service_id);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['service_type'] = $x->DataGetInt();
			$ret['service_id'] = $x->DataGetInt();
			$ret['service_name'] = $x->DataGetString();
			$ret['service_comment'] = $x->DataGetString();
			$ret['periodic_cost'] = $x->DataGetDouble();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}


	function rpcf_user5_get_user_info() { //-0x4006
		$ret=array();
		if (!$this->connection->urfa_call(-0x4006)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		if ($x = $this->connection->urfa_get_data()) {
			$ret['user_id'] = $x->DataGetInt();
			$ret['login'] = $x->DataGetString();
			$ret['basic_account'] = $x->DataGetInt();
			$ret['balance'] = $x->DataGetDouble();
			$ret['credit'] = $x->DataGetDouble();
			$ret['is_blocked'] = $x->DataGetInt();
			$ret['create_date'] = $x->DataGetInt();
			$ret['last_change_date'] = $x->DataGetInt();
			$ret['who_create'] = $x->DataGetInt();
			$ret['who_change'] = $x->DataGetInt();
			$ret['is_juridical'] = $x->DataGetInt();
			$ret['full_name'] = $x->DataGetString();
			$ret['juridical_address'] = $x->DataGetString();
			$ret['actual_address'] = $x->DataGetString();
			$ret['work_telephone'] = $x->DataGetString();
			$ret['home_telephone'] = $x->DataGetString();
			$ret['mobile_telephone'] = $x->DataGetString();
			$ret['web_page'] = $x->DataGetString();
			$ret['icq_number'] = $x->DataGetString();
			$ret['tax_number'] = $x->DataGetString();
			$ret['kpp_number'] = $x->DataGetString();
			$ret['bank_id'] = $x->DataGetInt();
			$ret['bank_account'] = $x->DataGetString();
			$ret['int_status'] = $x->DataGetInt();
			$ret['vat_rate'] = $x->DataGetDouble();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}


	function rpcf_user5_traffic_report($start_date,$end_date) { //-0x4009
		$ret=array();
		if (!$this->connection->urfa_call(-0x4009)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($start_date);
		$packet->DataSetInt($end_date);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['account_id'] = $x->DataGetInt();
			$ret['bytes_in_kbyte'] = $x->DataGetDouble();
			$ret['count'] = $x->DataGetInt();
			for ($i=0;$i<$ret['count'];$i++) {
				$x = $this->connection->urfa_get_data();
				$traf['tclass_id'] = $x->DataGetInt();
				$traf['tclass_name'] = $x->DataGetString();
				$traf['bytes'] = $x->DataGetLong();
				$traf['base_cost'] = $x->DataGetDouble();
				$traf['discount'] = $x->DataGetDouble();
				$traf['discount_with_tax'] = $x->DataGetDouble();
				$ret['traffic'][]=$traf;
			}
			$this->connection->urfa_get_data();
		}
		return $ret;
	}


	function rpcf_user5_get_remaining_seconds($user_id) { //-0x2027
		$ret=array();
		if (!$this->connection->urfa_call(-0x2027)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($user_id);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['remaining_seconds'] = $x->DataGetInt();
			$ret['downloaded_seconds'] = $x->DataGetInt();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}


	function rpcf_user5_get_remaining_traffic($user_id) { //-0x2026
		$ret=array();
		if (!$this->connection->urfa_call(-0x2026)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($user_id);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['traffic_remaining_mb'] = $x->DataGetDouble();
			$ret['traffic_downloaded_mb'] = $x->DataGetDouble();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}


	function rpcf_user5_get_group_id_by_name($name) { //-0x401b
		$ret=array();
		if (!$this->connection->urfa_call(-0x401b)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetString($name);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['group_name'] = $name;
			$ret['group_id'] = $x->DataGetInt();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}

	function rpcf_user5_get_service_id_by_name($name) { //-0x401e
		$ret=array();
		if (!$this->connection->urfa_call(-0x401e)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetString($name);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['service_name'] = $name;
			$ret['service_id'] = $x->DataGetInt();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}

	function rpcf_user5_get_tariff_id_by_name($name) { //-0x401a
		$ret=array();
		if (!$this->connection->urfa_call(-0x401a)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetString($name);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['tariff_name'] = $name;
			$ret['tariff_id'] = $x->DataGetInt();
			$this->connection->urfa_get_data();
		}
		return $ret;
	}

	function rpcf_user5_get_user_group_list() { //-0x401c
		$ret=array();
		if (!$this->connection->urfa_call(-0x401c)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$x = $this->connection->urfa_get_data();
		$ret['count'] = $x->DataGetInt();
		for ($i=0;$i<$ret['count'];$i++) {
			$group['id'] = $x->DataGetInt();
			$ret['groups'][]=$group;
		}
		$this->connection->urfa_get_data();
		return $ret;
	}

	function rpcf_user5_blocks_report($start_date,$end_date) { //-0x4013
		$ret=array();
		if (!$this->connection->urfa_call(-0x4013)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($start_date);
		$packet->DataSetInt($end_date);
		$this->connection->urfa_send_param($packet);
		$x = $this->connection->urfa_get_data();
		$ret['count']=$x->DataGetInt();
		for ($i=0;$i<$ret['count'];$i++) {
			$x = $this->connection->urfa_get_data();
			$block['account_id'] = $x->DataGetInt();
			$block['start_date'] = $x->DataGetInt();
			$block['expire_date'] = $x->DataGetInt();
			$block['what_blocked'] = $x->DataGetInt();
			$block['block_type'] = $x->DataGetInt();
			$block['comment'] = $x->DataGetString();
			$ret['block'][]=$block;
		}
		$this->connection->urfa_get_data();
		return $ret;
	}


	function rpcf_user5_brief_report_for_wintray() { //-0x4026
		$ret=array();
		if (!$this->connection->urfa_call(-0x4026)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$x = $this->connection->urfa_get_data();
		$ret['int_status']=$x->DataGetInt();
		$ret['balance']=$x->DataGetDouble();
		$this->connection->urfa_get_data();
		return $ret;
	}

	function rpcf_user5_change_int_status($status) { //-0x4007
		$ret=array();
		if (!$this->connection->urfa_call(-0x4007)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetInt($status);
		$this->connection->urfa_send_param($packet);
		$this->connection->urfa_get_data();
	}


	function rpcf_user5_get_services() { //-0x4023
		$ret=array();
		if (!$this->connection->urfa_call(-0x4023)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$x = $this->connection->urfa_get_data();
		$ret['count']=$x->DataGetInt();
		for ($i=0;$i<$ret['count'];$i++) {
			$x = $this->connection->urfa_get_data();
			$service['id'] = $x->DataGetInt();
			$service['service_id'] = $x->DataGetInt();
			$service['service_type'] = $x->DataGetInt();
			$service['service_name'] = $x->DataGetString();
			$service['tariff_name'] = $x->DataGetString();
			$service['discount_period'] = $x->DataGetString();
			$service['cost'] = $x->DataGetDouble();
			$service['discounted_in_curr_period'] = $x->DataGetDouble();
			$ret['services'][]=$service;
		}
		$this->connection->urfa_get_data();
		return $ret;
	}

	function rpcf_user5_payments_report($start_date,$end_date) { //-0x4012
		$ret=array(); 
		if (!$this->connection->urfa_call(-0x4012)) { 
			print "Error calling function ". __FUNCTION__ ."\n"; 
			return FALSE; 
		} 
		$packet = $this->connection->getPacket(); 
		$packet->DataSetInt($start_date); 
		$packet->DataSetInt($end_date); 
		$this->connection->urfa_send_param($packet); 
		$x = $this->connection->urfa_get_data(); 
		$ret['account_id']=$x->DataGetInt(); 
		$ret['atr_size']=$x->DataGetInt(); 
		for ($i=0;$i<$ret['atr_size'];$i++) { 
			$payment['actual_date'] = $x->DataGetInt(); 
			$payment['payment_enter_date'] = $x->DataGetInt(); 
			$payment['payment'] = $x->DataGetDouble(); 
			$payment['payment_incurrency'] = $x->DataGetDouble(); 
			$payment['currency_id'] = $x->DataGetInt(); 
			$payment['payment_method_id'] = $x->DataGetInt(); 
			$payment['payment_method'] = $x->DataGetString(); 
			$payment['comment'] = $x->DataGetString(); 
			$ret['payment'][]=$payment; 
		} 
		$this->connection->urfa_get_data(); 
		return $ret; 
	} 

	function rpcf_user5_service_report($start_date,$end_date) { //-0x4011
		$ret=array(); 
		if (!$this->connection->urfa_call(-0x4011)) { 
			print "Error calling function ". __FUNCTION__ ."\n"; 
			return FALSE; 
		} 
		$packet = $this->connection->getPacket(); 
		$packet->DataSetInt($start_date); 
		$packet->DataSetInt($end_date); 
		$this->connection->urfa_send_param($packet); 
		if ($x = $this->connection->urfa_get_data()) { 
			$ret['aids_size'] = $x->DataGetInt(); 
			for ($i=0;$i<$ret['aids_size'];$i++) { 
				$x = $this->connection->urfa_get_data(); 
				$services['asr_size'] = $x->DataGetInt(); 
				for($j=0;$j<$services['asr_size'];$j++){ 
					$x = $this->connection->urfa_get_data(); 
					$services['asr_size_array'][$j]['account_id'] = $x->DataGetInt(); 
					$services['asr_size_array'][$j]['discount_date'] = $x->DataGetInt(); 
					$services['asr_size_array'][$j]['discount'] = $x->DataGetDouble(); 
					$services['asr_size_array'][$j]['discount_with_tax'] = $x->DataGetDouble(); 
					$services['asr_size_array'][$j]['service_name'] = $x->DataGetString(); 
					$services['asr_size_array'][$j]['service_type'] = $x->DataGetInt(); 
					$services['asr_size_array'][$j]['comment'] = $x->DataGetString(); 
				} 
				$ret['services'][]=$services; 
			} 
			$this->connection->urfa_get_data(); 
		} 
		return $ret; 
	} 

	function rpcf_user5_get_services_info($slink_id) { //-0x4024
		$ret=array(); 
		if (!$this->connection->urfa_call(-0x4024)) { 
			print "Error calling function ". __FUNCTION__ ."\n"; 
			return FALSE; 
		} 
		$packet = $this->connection->getPacket(); 
		$packet->DataSetInt($slink_id); 
		$this->connection->urfa_send_param($packet); 
		$x = $this->connection->urfa_get_data(); 
		$ret['service_type']=$x->DataGetInt(); 
		$ret['service_id']=$x->DataGetInt(); 
		$ret['service_name']=$x->DataGetString(); 
		$ret['tariff_id']=$x->DataGetInt(); 
		$ret['discounted_in_curr_period']=$x->DataGetDouble(); 
		$ret['cost']=$x->DataGetDouble(); 
		$x = $this->connection->urfa_get_data(); 
		switch ($ret['service_type']){ 
			case "3": 
				$ret['bytes_in_mbyte']=$x->DataGetInt(); 
				$ret['iptsl_downloaded_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['iptsl_downloaded_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['iptsl_downloaded_size_list'][$i]['tclass']=$x->DataGetString(); 
					$ret['iptsl_downloaded_size_list'][$i]['downloaded']=$x->DataGetLong(); 
				} 
				$x = $this->connection->urfa_get_data(); 
				$ret['iptsl_old_prepaid_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['iptsl_old_prepaid_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['iptsl_old_prepaid_size_list'][$i]['tclass']=$x->DataGetString(); 
					$ret['iptsl_old_prepaid_size_list'][$i]['downloaded']=$x->DataGetLong(); 
				} 
				$x = $this->connection->urfa_get_data(); 
				$ret['ipgroup_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['ipgroup_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['ipgroup_size_list'][$i]['item_id']=$x->DataGetInt(); 
					$ret['ipgroup_size_list'][$i]['ip']=$x->DataGetIPAddress(); 
					$ret['ipgroup_size_list'][$i]['mask']=$x->DataGetIPAddress(); 
					$ret['ipgroup_size_list'][$i]['login']=$x->DataGetString(); 
				} 
				$x = $this->connection->urfa_get_data(); 
				$ret['iptsd_borders_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['iptsd_borders_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['iptsd_borders_size_list'][$i]['tclass_name']=$x->DataGetString(); 
					$ret['iptsd_borders_size_list'][$i]['bytes']=$x->DataGetLong(); 
					$ret['iptsd_borders_size_list'][$i]['cost1']=$x->DataGetDouble(); 
					$ret['iptsd_borders_size_list'][$i]['group_type']=$x->DataGetInt(); 
				} 
				$x = $this->connection->urfa_get_data(); 
				$ret['iptsd_prepaid_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['iptsd_prepaid_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['iptsd_prepaid_size_list'][$i]['tclass_name_p']=$x->DataGetString(); 
					$ret['iptsd_prepaid_size_list'][$i]['prepaid_p']=$x->DataGetLong(); 
				} 
			   break; 
			case "6": 
				$ret['tsl_numbers_size']=$x->DataGetInt(); 
				for ($i=0;$i<=$ret['tsl_numbers_size']-1;$i++){ 
					$x = $this->connection->urfa_get_data(); 
					$ret['tsl_numbers_size_list'][$i]['number']=$x->DataGetString(); 
					$ret['tsl_numbers_size_list'][$i]['login']=$x->DataGetString(); 
					$ret['tsl_numbers_size_list'][$i]['allowed_cid']=$x->DataGetString(); 
					$ret['tsl_numbers_size_list'][$i]['item_id']=$x->DataGetInt(); 
				} 
				break; 
			default: 
				$ret['null_param']=$x->DataGetInt(); 
				break; 
		} 
		$this->connection->urfa_get_data(); 
		return $ret; 
	}

	function rpcf_user5_change_password($old_password,$new_password,$new_password_ret) { //-0x4021
		$ret=array();
		if (!$this->connection->urfa_call(-0x4021)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket();
		$packet->DataSetString($old_password);
		$packet->DataSetString($new_password);
		$packet->DataSetString($new_password_ret);
		$this->connection->urfa_send_param($packet);
		if ($x = $this->connection->urfa_get_data()) {
			$ret['result'] = $x->DataGetInt();
		}
		return $ret;
	}

	function rpcf_user5_get_accounts() { //-0x4055
		$ret=array();
		if (!$this->connection->urfa_call(-0x4055)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$x = $this->connection->urfa_get_data();
		$ret['accounts_size']=$x->DataGetInt();
		for ($i=0;$i<$ret['accounts_size'];$i++) {
			$x = $this->connection->urfa_get_data();
			$account['account_id'] = $x->DataGetInt();
			$account['balance'] = $x->DataGetDouble();
			$account['credit'] = $x->DataGetDouble();
			$ret['accounts'][]=$account;
		}
		$this->connection->urfa_get_data();
		return $ret;
	}

	function rpcf_user5_switch_internet_on_disconnect($on) { //-0x4030
		if (!$this->connection->urfa_call(-0x4030)) {
			print "Error calling function ". __FUNCTION__ ."\n";
			return FALSE;
		}
		$packet = $this->connection->getPacket(); 
		$packet->DataSetInt($on); 
		$this->connection->urfa_send_param($packet); 
		$this->connection->urfa_get_data();
	}
	
}

?>